CREATE TYPE "status" AS ENUM (
  'Active',
  'Deprecated'
);

CREATE TYPE "acceptance" AS ENUM (
  'Official',
  'Experimental',
  'Provisional',
  'Proprietary'
);

CREATE TYPE "aggregation_method" AS ENUM (
  'Measured',
  'Calculated'
);

CREATE TYPE "collection" AS ENUM (
  'Modus_Soil_Test_v1',
  'Modus_Soil_Test_v2',
  'Modus_Botanical_Test_v1',
  'Modus_Botanical_Test_v2',
  'OpenTeam'
);

CREATE TYPE "element_type" AS ENUM (
  'soil',
  'botanical'
);

CREATE TABLE "Modus_Soil_Test_v1" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "analyte_id" int,
  "extraction_method_id" int,
  "measurement_method_id" int,
  "unit_of_measurment_default_id" int
);

CREATE TABLE "modusSoilv1_altUnitsOfMeasurement" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "modus_soil_test_v1_id" int,
  "unit_of_measurment_id" int
);

CREATE TABLE "Modus_Soil_Test_v2" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "analyte_id" int,
  "extraction_method_id" int,
  "extraction_reagent_formulation_id" int,
  "extraction_ratio_id" int,
  "extraction_basis_id" int,
  "extraction_time_id" int,
  "measurement_method_id" int,
  "aggregation_method" aggregation_method,
  "unit_of_measurment_default_id" int,
  "unit_of_measurement_alt_id" int,
  "acceptance" acceptance,
  "status" status,
  "citation" varchar,
  "modus_soil_test_v1_id" int
);

CREATE TABLE "modusSoilv2_organizations" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "organization_id" int,
  "modus_soil_test_v2_id" int
);

CREATE TABLE "Organization" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "name" varchar
);

CREATE TABLE "Modus_Botanical_Test_v1" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "analyte_id" int,
  "common_name" varchar,
  "extraction_method_id" int,
  "measurement_method_id" int,
  "unit_of_expression_id" int
);

CREATE TABLE "modusBotanicalv1_altUnitsOfExpression" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "modus_botanical_test_v1_id" int,
  "unit_of_expression_id" int
);

CREATE TABLE "Modus_Botanical_Test_v2" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "analyte_id" int,
  "common_name" varchar,
  "extraction_method_id" int,
  "measurement_method_id" int,
  "unit_of_expression_id" int,
  "extraction_reagent_formulation_id" int,
  "extraction_ratio_id" int,
  "extraction_basis_id" int,
  "unit_of_measurment_default_id" int,
  "unit_of_measurement_alt_id" int,
  "acceptance" acceptance,
  "citation" varchar
);

CREATE TABLE "modusBotanicalv2_organizations" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "organization_id" int,
  "modus_botanical_test_v2_id" int
);

CREATE TABLE "Analytes" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "analyte_name" varchar
);

CREATE TABLE "Extraction_Methods" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "extraction_method_name" varchar
);

CREATE TABLE "Measurement_Methods" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "measurement_method_name" varchar
);

CREATE TABLE "Extraction_Reagent_Formulation" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "extraction_reagent_formulation_name" varchar
);

CREATE TABLE "Extraction_Ratio" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "extraction_ratio_name" varchar
);

CREATE TABLE "Extraction_Basis" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "extraction_basis_name" varchar
);

CREATE TABLE "Extraction_Time" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "extraction_time_name" varchar
);

CREATE TABLE "Units_of_Measurment" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "unit_of_measurement_name" varchar,
  "ucum_unit_string" varchar
);

CREATE TABLE "Labs" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "lab_name" varchar,
  "testing_service_website" varchar,
  "location" varchar,
  "contact_email" varchar,
  "example_test_result_url" varchar
);

CREATE TABLE "Lab_Certifications" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "certification_id" int,
  "lab_id" int
);

CREATE TABLE "Lab_Packages" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "package_name" varchar,
  "lab_id" int,
  "package_link" varchar,
  "status" status
);

CREATE TABLE "Lab_Methods_Modus" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "lab_method_id" int,
  "element_type" element_type,
  "modus_id" varchar,
  "modus_soil_test_v1_id" int,
  "modus_soil_test_v2_id" int,
  "modus_botanical_test_v1" int,
  "modus_botanical_test_v2" int
);

CREATE TABLE "Lab_Specified_Methods" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "lab_id" int,
  "element_type" element_type,
  "analyte_id" int,
  "extraction_method_id" int,
  "extraction_regent_formulation_id" int,
  "extraction_ratio_id" int,
  "extraction_basis_id" int,
  "extraction_time_id" int,
  "measurement_method_id" int,
  "aggregation_method" aggregation_method,
  "unit_of_measurment_default_id" int,
  "unit_of_measurement_alt_id" int,
  "acceptance" acceptance,
  "status" status,
  "citation" varchar
);

CREATE TABLE "Certifications" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "certification_name" varchar,
  "certification_agency" varchar
);

CREATE TABLE "lab_packages_methods" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY UNIQUE PRIMARY KEY NOT NULL,
  "package_id" int,
  "medhod_id" int
);

ALTER TABLE "Modus_Soil_Test_v1" ADD FOREIGN KEY ("analyte_id") REFERENCES "Analytes" ("id");

ALTER TABLE "Modus_Soil_Test_v1" ADD FOREIGN KEY ("extraction_method_id") REFERENCES "Extraction_Methods" ("id");

ALTER TABLE "Modus_Soil_Test_v1" ADD FOREIGN KEY ("measurement_method_id") REFERENCES "Measurement_Methods" ("id");

ALTER TABLE "Modus_Soil_Test_v1" ADD FOREIGN KEY ("unit_of_measurment_default_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "modusSoilv1_altUnitsOfMeasurement" ADD FOREIGN KEY ("modus_soil_test_v1_id") REFERENCES "Modus_Soil_Test_v1" ("id");

ALTER TABLE "modusSoilv1_altUnitsOfMeasurement" ADD FOREIGN KEY ("unit_of_measurment_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("analyte_id") REFERENCES "Analytes" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("extraction_method_id") REFERENCES "Extraction_Methods" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("extraction_reagent_formulation_id") REFERENCES "Extraction_Reagent_Formulation" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("extraction_ratio_id") REFERENCES "Extraction_Ratio" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("extraction_basis_id") REFERENCES "Extraction_Basis" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("extraction_time_id") REFERENCES "Extraction_Time" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("measurement_method_id") REFERENCES "Measurement_Methods" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("unit_of_measurment_default_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("unit_of_measurement_alt_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Soil_Test_v2" ADD FOREIGN KEY ("modus_soil_test_v1_id") REFERENCES "Modus_Soil_Test_v1" ("extraction_method_id");

ALTER TABLE "modusSoilv2_organizations" ADD FOREIGN KEY ("organization_id") REFERENCES "Organization" ("id");

ALTER TABLE "modusSoilv2_organizations" ADD FOREIGN KEY ("modus_soil_test_v2_id") REFERENCES "Modus_Soil_Test_v2" ("id");

ALTER TABLE "Modus_Botanical_Test_v1" ADD FOREIGN KEY ("analyte_id") REFERENCES "Analytes" ("id");

ALTER TABLE "Modus_Botanical_Test_v1" ADD FOREIGN KEY ("extraction_method_id") REFERENCES "Extraction_Methods" ("id");

ALTER TABLE "Modus_Botanical_Test_v1" ADD FOREIGN KEY ("measurement_method_id") REFERENCES "Measurement_Methods" ("id");

ALTER TABLE "Modus_Botanical_Test_v1" ADD FOREIGN KEY ("unit_of_expression_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "modusBotanicalv1_altUnitsOfExpression" ADD FOREIGN KEY ("modus_botanical_test_v1_id") REFERENCES "Modus_Botanical_Test_v1" ("id");

ALTER TABLE "modusBotanicalv1_altUnitsOfExpression" ADD FOREIGN KEY ("unit_of_expression_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("analyte_id") REFERENCES "Analytes" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("extraction_method_id") REFERENCES "Extraction_Methods" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("measurement_method_id") REFERENCES "Measurement_Methods" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("unit_of_expression_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("extraction_reagent_formulation_id") REFERENCES "Extraction_Reagent_Formulation" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("extraction_ratio_id") REFERENCES "Extraction_Ratio" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("extraction_basis_id") REFERENCES "Extraction_Basis" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("unit_of_measurment_default_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Modus_Botanical_Test_v2" ADD FOREIGN KEY ("unit_of_measurement_alt_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "modusBotanicalv2_organizations" ADD FOREIGN KEY ("organization_id") REFERENCES "Organization" ("id");

ALTER TABLE "modusBotanicalv2_organizations" ADD FOREIGN KEY ("modus_botanical_test_v2_id") REFERENCES "Modus_Botanical_Test_v2" ("id");

ALTER TABLE "Lab_Certifications" ADD FOREIGN KEY ("certification_id") REFERENCES "Certifications" ("id");

ALTER TABLE "Lab_Certifications" ADD FOREIGN KEY ("lab_id") REFERENCES "Labs" ("id");

ALTER TABLE "Lab_Packages" ADD FOREIGN KEY ("lab_id") REFERENCES "Labs" ("id");

ALTER TABLE "Lab_Methods_Modus" ADD FOREIGN KEY ("lab_method_id") REFERENCES "Lab_Specified_Methods" ("id");

ALTER TABLE "Lab_Methods_Modus" ADD FOREIGN KEY ("modus_soil_test_v1_id") REFERENCES "Modus_Soil_Test_v1" ("id");

ALTER TABLE "Lab_Methods_Modus" ADD FOREIGN KEY ("modus_soil_test_v2_id") REFERENCES "Modus_Soil_Test_v2" ("id");

ALTER TABLE "Lab_Methods_Modus" ADD FOREIGN KEY ("modus_botanical_test_v1") REFERENCES "Modus_Botanical_Test_v1" ("id");

ALTER TABLE "Lab_Methods_Modus" ADD FOREIGN KEY ("modus_botanical_test_v2") REFERENCES "Modus_Botanical_Test_v2" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("lab_id") REFERENCES "Labs" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("analyte_id") REFERENCES "Analytes" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("extraction_method_id") REFERENCES "Extraction_Methods" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("extraction_regent_formulation_id") REFERENCES "Extraction_Reagent_Formulation" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("extraction_ratio_id") REFERENCES "Extraction_Ratio" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("extraction_basis_id") REFERENCES "Extraction_Basis" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("extraction_time_id") REFERENCES "Extraction_Time" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("measurement_method_id") REFERENCES "Measurement_Methods" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("unit_of_measurment_default_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "Lab_Specified_Methods" ADD FOREIGN KEY ("unit_of_measurement_alt_id") REFERENCES "Units_of_Measurment" ("id");

ALTER TABLE "lab_packages_methods" ADD FOREIGN KEY ("package_id") REFERENCES "Lab_Packages" ("id");

ALTER TABLE "lab_packages_methods" ADD FOREIGN KEY ("medhod_id") REFERENCES "Lab_Specified_Methods" ("id");
